import time
import serial
from datetime import datetime
class SerialDriver:
    serialDevice: serial.Serial
    waitTime = 0.0

    def __init__(self, com_port: str):
        #110, 300, 1200, 2400, 4800, 9600, 19200, 38400, 57600, or 115200
    
        #(26874122 ) / (128 × (N + 1))
        N = 0
        n = 0
        cpu = 26874122 #26874122 # 28636363
        speed = round(cpu/((N+1) * 256 * pow(2,2 * n - 1)))
        #speed =  115200 #209954 
        #speed =  209956
        #print("Current speed:%s n%s N:%s" % (speed,n,N))
 
        self.serialDevice = serial.Serial(com_port,speed,timeout=60)
        
        
        
   
    def read(self) -> bytearray:
      
        data = self.serialDevice.read(1)
        if len(data) == 0:
            return b""
        
        data += self.serialDevice.read(self.serialDevice.in_waiting )
        
        #make sure end of string is not a possible error code
        if data[-1] == b'\xFF' and data[-2] != b'\xFF':
            data += self.serialDevice.read(1 )
            
        index = data.index(b"\xFF00")
        #make sure FF00 is an error code and not a value (FFFF == FF) 
        if index >= 0:
            head = data[index + 2]
            data = data.replace(b"\xFF00" + head,b"")
            tail = ringBufferIdx
            resend = b''
            while head != tail:
                resend += ringBuffer[head]
                head += 1
                head &= 0xFF
             
            
        data = data.replace(b"\xFFFF",b"\xFF")
        print("SD:Read %s" % data)    
        return data
    
    ringBuffer : []
    ringBufferIdx = 0
    def write(self,data):
        for d in data:
            ringBuffer[ringBufferIdx] = d
            ringBufferIdx += 1
            ringBufferIdx &= 0xFF
            
        self.serialDevice.write(data)
        #print("SD:Write %s" % data)
        self.serialDevice.flush()
    def connect(self):
        try:
            
            while(True):
                
                now = datetime.now()
                char = self.read()
                if len(char) > 0:
                    print(char)
             
                
                if not char or not b'*' in char:
                    continue
                
                
                print("Connect to Access Point finished")
                

                time_digit_heard = now
                while (datetime.now() - time_digit_heard).total_seconds() < self.waitTime:
                    continue;
            
                return self.serialDevice.is_open
        except IOError as error:
            return False
                

    def disconnect(self):
        pass
        
    def flush(self):
        self.serialDevice.flush()