import time
import socket
import select
import os
import sys
import atexit
import threading

from datetime import datetime
class TCPModemDriver:

    readTime = 0.0
    tcp: socket.socket = None

    timeout = 0.1
    
    peername = ""
    isAlive = False
    port = None
    
    def __init__(self,port = None):
        self.port = port
        atexit.register(self.exit_handler)
        
    def exit_handler(self):
        pass    

    def connect(self) -> bool:
        if self.isAlive == True:
            print("TD Is alive");
            return True
        
        self.isAlive = self.connecting()
        
        
        return self.isAlive          
    
    def connecting(self):
        dummy1: socket.socket = None
        dummy2: socket.socket = None
        
        if self.tcp:
            self.tcp.close()
        if dummy1:
            dummy1.close()
        if dummy2:
            dummy2.close()
            
        
        print("TD:Connecting to host 127.0.0.1") 
        if self.port is None:
            is1337Good = False
            is1338Good = False
            
            accessScan = b""
            while True:
                
                try:
                    if is1338Good == False:
                        print("TD:Checking port 1338")
                        dummy2 = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
                        dummy2.settimeout(120)
                        dummy2.connect(("127.0.0.1",1338)) 
                        dummy2.settimeout(0.01)
                        print("TD:Device found. Waiting on handshake")
                        is1338Good = True
            
                                            
                except:
                    print("TD:Port 1338 failed")
                    is1338Good = False
                    
                try:
                    if is1337Good == False:
                        print("TD:Checking port 1337")
                        dummy1 = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
                        dummy1.settimeout(120)
                        dummy1.connect(("127.0.0.1",1337)) 
                        dummy1.settimeout(0.01)
                        print("TD:Device found. Waiting on handshake")
                        is1337Good = True
                except:
                    print("TD:Port 1337 failed")
                    is1337Good = False
                
                    
                    
                if not is1337Good and not is1338Good:
                    continue
                    
                try:
                    if is1337Good:
                        
                        accessScan += dummy1.recv(2048)
                        
                        if len(accessScan) > 0:
                            self.tcp = dummy1
                            if dummy2:
                                dummy2.close()
                            break;
                except Exception as ex:
                    if "close" in str(ex):
                        print("TD:Error (102) %s" % ex)
                        is1337Good = False
                        break
                    pass
                    
                try:
                    if is1338Good:
                        accessScan += dummy2.recv(2048)                        
                        if len(accessScan) > 0:
                            self.tcp = dummy2
                            if dummy1:
                                dummy1.close()
                            break;
                except Exception as ex:
                    if "close" in str(ex):
                        print("TD:Error (117) %s" % ex)
                        is1338Good = False
                        break
                    pass
           
           
            if self.tcp is None:
                return False
        else:
            print("TD:Port %d" % self.port)
            accessScan = b""
            while True:
                try:
                    self.tcp = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
                    self.tcp.settimeout(120)
                    print("TD:Attempting connect on %d" % self.port)
                    self.tcp.connect(("127.0.0.1",self.port)) 
                    self.tcp.settimeout(0.01)
                    break;
                except Exception as ex:
                    continue
            
                print("TD:Connected on %d" % self.port)
            while True:
                try:  
                    accessScan += self.tcp.recv(2048) 
                    if len(accessScan) > 0:
                        break;
                except Exception as ex:
                    if "close" in str(ex):
                        print("TD:Error (117) %s" % ex)
                        continue
                    continue
                    
                    
        self.tcp.settimeout(120)
        self.tcp.setsockopt(socket.IPPROTO_TCP, socket.TCP_NODELAY, 1)
        self.peername = self.tcp.getpeername()[0] + ":" + str(self.tcp.getpeername()[1])
        
        print("TD:Connected at %s" % self.peername)
        
        while(True):
            if not b'*' in accessScan:
                accessScan += self.read()
                continue

            print("TD:Connect to Access Point finished %s %s\n\n" % (self.peername,accessScan))
            return True

    def read(self ) -> bytearray:
        try:
            data = self.tcp.recv(32)
            if len(data)== 0:
                self.disconnect()
                raise Exception("Error: Connection closed")
            #print("TD:Read %s" % data) 
        except BlockingIOError:
            return False  # socket is open and reading from it would block
        except ConnectionResetError:
            print("TD:Reset" % data) 
            return True  # socket was closed for some other reason
        except Exception as ex:
            print("TD: (145)" +str(ex))
            if "Error" in str(ex):
                raise
        return data
        

    def write(self,data):      
        self.tcp.sendall(data)

    def flush(self):
        try:
            self.tcp.settimeout(0)
            while(len(self.read()) > 0):
                pass
        except:
            pass
        finally:
            if self.tcp:
                self.tcp.settimeout(120)

    def disconnect(self):
        print("TD:Disconnect") 
        self.isAlive = False
        if self.tcp:
            self.tcp.close()
            self.tcp = None
            
