# -*- coding: utf-8 -*-
"""
Created on Thu May 19 08:01:31 2022

@author: joe
"""
#netlink_version=1663872260.57
import sys

if __name__ == "__main__":
    print("This script should not be run on its own")
    sys.exit()

from datetime import datetime

import socket
import time
import logging
import threading
import binascii
import select



class Tunnel():
    logger = logging.getLogger('dreampi')

    printout = False
    if 'printout' in sys.argv:
        printout = True
    
    conn = None
    remoteAddress = ""

    udp : socket.socket = None
    tcpServer : socket.socket = None
    tcpClient : socket.socket = None
    msgBuffer = b""
    msgSendBuffer = b""
    msgListenBuffer = b""
    def listening(self):
        print("Attempting to wait")
        try:
            self.timerStart = time.time()
            PORT = 65432
            self.tcpServer = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
            self.tcpServer.settimeout(120)
            self.tcpServer.bind(('', PORT))
            print("I'm listening on port: %d" % PORT)
            self.tcpServer.listen(5)
        except:
            print("Port in use, dial allowed only")
        return 


        
    def accept(self) -> bool:
        ready = select.select([self.tcpServer], [], [],0)
        if ready[0]:
            print("Accepting")
            self.conn, addr = self.tcpServer.accept()
            self.remoteAddress = addr[0]
            return True
        return False        

    def acknowledge(self):
        self.conn.sendall(b'ack|')
        
    def messages(self):
    
        if len(self.msgBuffer.split(b'|')) <= 1: 
            self.msgBuffer += self.conn.recv(1024)
        word = self.msgBuffer.split(b'|')
        result = word[0]
        self.msgBuffer = self.msgBuffer[len(result) + 1:]
        if result is None:
            result = b""
        return result
    def messagesServer(self):
    
        if len(self.msgListenBuffer.split(b'|')) <= 1: 
            self.msgListenBuffer += self.tcpServer.recv(1024)
        word = self.msgListenBuffer.split(b'|')
        result = word[0]
        self.msgListenBuffer = self.msgListenBuffer[len(result) + 1:]
        if result is None:
            result = b""
        return result
 
#####################################################################            
    def messagesClient(self):
    
        if len(self.msgSendBuffer.split(b'|')) <= 1: 
            self.msgSendBuffer += self.tcpClient.recv(1024)
        word = self.msgSendBuffer.split(b'|')
        result = word[0]
        self.msgSendBuffer = self.msgSendBuffer[len(result) + 1:]
        if result is None:
            result = b""
        return result
 

    def begin(self):
        self.conn.sendall(b'g2gip|')
    
     
    def initConnection(self,dial_string,playerID,opponentName):
        print("Initializing for:%s" % dial_string)
        
        ip_set = dial_string.replace('*','.').split('.')
        for i,set in enumerate(ip_set): #socket connect doesn't like leading zeroes now
            fixed = str(int(set))
            ip_set[i] = fixed
            
        self.remoteAddress = ('.').join(ip_set)

        print("I'm calling")
        PORT = 65432
        self.tcpClient = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
        self.tcpClient.settimeout(120)
        try:
            print("Attempting to connect to %s" % opponentName.strip())
            
            self.tcpClient.connect((self.remoteAddress, PORT))
            self.tcpClient.sendall(b"name:%s|" % playerID.strip().encode())
            
            char = self.messagesClient()
            while len(char) == 0:
                char = self.messagesClient()
            if char == b"|":
                print("cancelled")
                return "waiting"
            if char == b"$":
            
                print("connected")
                return "failed"
                
        except socket.error:
            print(socket.error)
            self.remoteAddress = ""
            return "failed"
    
    def checkAcknowledge(self) -> bool:
        print("blocking")
        ready = select.select([self.tcpClient], [], [])
        print("unblocking")
        
        if ready[0]:
            data = self.messagesClient()
            print("TCP ack %s" % data)
            if data == b'ack':
                return True
        return False       
    
    def ready(self):
        try:
            self.tcpClient.sendall(b"readyip|")
            print("Ready sent")
            ready = select.select([self.tcpClient], [], [])
            if ready[0]:
                data = self.messagesClient()
                print("TCP %s" % data)
                if data == b'g2gip':
                    #notify device a tunnel is established
                   
                    print("Ready for Data Exchange!")
                    #tcp.shutdown(socket.SHUT_RDWR)
                    #tcp.close()
                    return "connected"
                return "failed"
        except socket.error:
            print(socket.error)
            self.remoteAddress = ""
            return "failed"
             

##############################################################
    def establishUDPConnection(self,port):
        self.udp = socket.socket(socket.AF_INET, socket.SOCK_DGRAM)
        self.udp.setblocking(0)
        self.udp.bind(('', port))
        time.sleep(1)

    def sendUDP(self, data,remotePort):
        #print("Tunnel: sendUDP %d:%d" % (self.remoteAddress,remotePort))
        try:
            for i in range(2): #send the data twice. May help with drops or latency    
                ready = select.select([],[self.udp],[]) #blocking select  
                if ready[1]:
                    self.udp.sendto(data, (self.remoteAddress,remotePort))
        except:
            pass     
    
    def recvUDP(self):
        try:
            #print("Tunnel: recvUDP %d" % self.udp.getsockname()[1])
            ready = select.select([self.udp],[],[]) #polling select
            if ready[0]:
               packetSet = self.udp.recv(1024)
               #print("Tunnel: recvUDP %s" % data)
               return packetSet
        except:
            pass
        return None
    def closeUDP(self):
        self.udp.close()
        
    
