# -*- coding: utf-8 -*-
"""
Created on Thu May 19 08:01:31 2022

@author: joe
"""
#netlink_version=1663872260.57
import sys

if __name__ == "__main__":
    print("UT:This script should not be run on its own")
    sys.exit()

from datetime import datetime

import socket
import time

import threading
import binascii
import select
from multiprocessing import Process

class UDPTunnel():
    state = ""
    isAlive = True
    DIALSEND = 20001
    DIALRECV = 20002
    accessPoint = None
    LISTENSEND = DIALRECV
    LISTENRECV = DIALSEND
    
    
    recvPort = 0
    sendPort = 0
    
 
    t1 : threading.Thread
    t2 : threading.Thread
    
    listenerLog = []
    senderLog = []
    printout = False
    if 'printout' in sys.argv:
        printout = True
    
    remoteAddress = ""

    udp : socket.socket = None
    
    def beginExchange(self, accessPoint,remoteAddress, listener = False):
        
        print("UT:Beginning exchange on %s" % remoteAddress)
        
        self.remoteAddress = remoteAddress
        self.accessPoint = accessPoint
        self.sendPort = self.DIALSEND
        self.recvPort = self.DIALRECV
        
        if listener:
            self.sendPort = self.LISTENSEND
            self.recvPort = self.LISTENRECV
            
            
        print("UT:Starting threads")
        self.t1 = threading.Thread(target=self.listener, daemon=True)
        print("UT:Thread 1")
        self.t2 = threading.Thread(target=self.sender,args=[self.sendPort], daemon=True)
        print("UT:Thread 2")
        
        
        
        self.udp = socket.socket(socket.AF_INET, socket.SOCK_DGRAM)
        #self.udp.setblocking(False)
        self.udp.settimeout(120)
        self.udp.bind(("", self.recvPort))
        
        time.sleep(1)
        print("UT:Establish")
            
        
        self.t1.start()
        self.t2.start()
        
        #halts the main thread
        self.t1.join()
        self.t2.join()
        
        self.isAlive = False
        self.close()
    
    
    def listener(self):
        print("UT:listening")
        last = 0
        currentSequence = 0
        try:
            while(self.state != "netlink_disconnected"):                   
                packetSet = self.udp.recv(2048)
                   
                if packetSet and len(packetSet) > 0:
                    packetSplit = b"<packetSplit>"
                    dataSplit = b"<dataSplit>"
                    packets= packetSet.split(packetSplit)
                    try:
                    
                        while True:
                            packetNum = 0
                            
                            #go through all packets 
                            for p in packets:
                              if int(p.split(dataSplit)[1]) == currentSequence:
                                break
                              packetNum += 1
                            
                            #if the packet needed is not here,  grab the latest in the set
                            if packetNum == len(packets):
                                packetNum = 0
                            
                            message = packets[packetNum]
                            payload = message.split(dataSplit)[0]
                            sequence = message.split(dataSplit)[1]
                            if int(sequence) < currentSequence:
                                break  #All packets are old data, so drop it entirely
                            
                            currentSequence = int(sequence) + 1
                            
                            toSend = payload
                            
                            self.accessPoint.write(toSend)
                            if len(payload) > 0:
                                self.listenerLog.append(payload)
                            if packetNum == 0: # if the first packet was the processed packet,  no need to go through the rest
                                break

                    except IndexError:
                        continue
                    except Exception as error:
                        print("UT:"+str(error))

                        break
        except Exception as error:
            print("UT:"+str(error))
            
        print("UT:listener stopped")                      
        f = open("listener%d.txt" % self.recvPort, "wb")
  
        for line in self.listenerLog:
            f.write(line)
        f.close()      
                
    def sender(self,oppPort):
        print("UT:sending")
        last = 0
        sequence = 0
        packets = []
        packetSplit = b"<packetSplit>"
        dataSplit = b"<dataSplit>"
        try:
            while(self.state != "netlink_disconnected"):
                raw_input = self.accessPoint.read()
               
                if raw_input is None or len(raw_input) == 0:
                    continue
                
                if b"NO CARRIER" in raw_input:
                    self.state = "netlink_disconnected"
                    time.sleep(1)
                    self.udp.close()
                    print("UT:sender stopped")
                    break
                
                try:
                    payload = raw_input
                    
                    seq = str(sequence)
                    if len(payload)>0:
                        self.senderLog.append(payload)
                        packets.insert(0,(payload+dataSplit+seq.encode()))
                        if(len(packets) > 5):
                            packets.pop()

                        self.udp.sendto(packetSplit.join(packets), (self.remoteAddress,oppPort))                    
                        sequence+=1
                except Exception as error:
                    print("UT:"+str(error))

                    break
            
        except:
            pass
        
        f = open("sender%d.txt" % self.recvPort, "wb")
        for line in self.senderLog:
            f.write(line)
        f.close()
        
    

        
    def close(self):
        self.isAlive = False
        self.udp.close()
        
    
